import { select, json, geoPath, geoNaturalEarth1 } from 'd3';
import { feature } from 'topojson';

const svg = select('svg');

// NaturalEarth1 projection
const projection = geoNaturalEarth1();

// given a JSON geometry object, to generates an SVG path
const pathGenerator = geoPath().projection(projection);

//Renders the path to a Canvas by appending path generated by pathgenerator to svg
svg.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

//Loading Json with values of land and interiors
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
  	//extracting coutries features
    const countries = feature(data, data.objects.countries);
  
  	//rendering countries borders path.
    svg.selectAll('path').data(countries.features)
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator);
  });